'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function () {

    function destructChain(path, arr, lookup, refVar) {
        if (!arr) {
            var arr = [];
        }
        if (_babelCore.types.isCallExpression(path.node)) {
            if (_babelCore.types.isIdentifier(path.node.callee, { name: "$" })) {
                if (!refVar) {
                    var ast = lookup.$(path, path.node.arguments);
                    arr.push(ast);
                    refVar = ast.declarations[0].id;
                    return refVar;
                } else {
                    var _ast = lookup.$(path, path.node.arguments, refVar);
                    arr.push(_ast);
                    return refVar;
                }
            } else if (_babelCore.types.isMemberExpression(path.node.callee)) {

                var id = destructChain(path.get("callee").get("object"), arr, lookup, refVar);
                if (id) {
                    if (typeof lookup[path.node.callee.property.name] === "function") {
                        var temp = lookup[path.node.callee.property.name](path, path.node.arguments, id);
                        if (!temp) {
                            //TODO: error code
                            console.log("UTIL NOT WORKING!");
                        }

                        if (temp.length) {
                            for (var i = 0; i < temp.length; i++) {
                                arr.push(temp[i]);
                            }
                        } else {
                            arr.push(temp);
                        }
                        return id;
                    } else {
                        //TODO:error handling
                        throw path.buildCodeFrameError("Unrecognized function name");
                        return null;
                    }
                } else {
                    return null;
                }
            } else {
                return null;
            }
        } else {

            return null;
        }
    }

    return {
        name: "ast-transform",
        visitor: {

            ExpressionStatement: function ExpressionStatement(path, state) {
                if (!this._lookup) {
                    this._lookup = util.createLookup(state.opts.naming);
                }
                if (_babelCore.types.isCallExpression(path.node.expression)) {
                    var new_statements = [];
                    var refVar = destructChain(path.get("expression"), new_statements, this._lookup);
                    if (!refVar) {
                        return;
                    }

                    path.replaceWithMultiple(new_statements);
                    path.skip();
                } else if (_babelCore.types.isAssignmentExpression(path.node.expression) && path.node.expression.operator === "=" && _babelCore.types.isCallExpression(path.node.expression.right)) {
                    var _new_statements = [];
                    var _refVar = destructChain(path.get("expression").get("right"), _new_statements, this._lookup, path.node.expression.left);
                    if (!_refVar) {
                        return;
                    }
                    path.replaceWithMultiple(_new_statements);
                    path.skip();
                }
            },
            VariableDeclarator: function VariableDeclarator(path, state) {
                if (!this._lookup) {
                    this._lookup = util.createLookup(state.opts.naming);
                }
                if (_babelCore.types.isCallExpression(path.node.init)) {
                    var new_statements = [];
                    var refVar = destructChain(path.get('init'), new_statements, this._lookup, path.node.id);
                    if (!refVar) {
                        return;
                    }
                    var stmt = _babelCore.types.variableDeclarator(path.node.id);
                    path.parentPath.insertAfter(new_statements);
                    path.replaceWith(stmt);
                    path.skip();
                }
            },
            CallExpression: function CallExpression(path, state) {
                if (!this._lookup) {
                    this._lookup = util.createLookup(state.opts.naming);
                }
                var new_statements = [];
                var refVar = destructChain(path, new_statements, this._lookup);
                if (!refVar) {
                    return;
                }
                path.getStatementParent().insertBefore(new_statements);
                path.replaceWith(refVar);
            }
        }
    };
};

var _util = require('./util.js');

var util = _interopRequireWildcard(_util);

var _babelCore = require('babel-core');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

;