'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.createLookup = createLookup;

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _babelTemplate = require('babel-template');

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

var _babelGenerator = require('babel-generator');

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

var _adjNoun = require('adj-noun');

var _adjNoun2 = _interopRequireDefault(_adjNoun);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var jQuery_lookup = function () {
    function jQuery_lookup() {
        var naming = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "AdjectiveNoun";

        _classCallCheck(this, jQuery_lookup);

        _adjNoun2.default.seed(Date.now());

        var uid_regexp = /(\w+)-UID/;
        this.naming = "UID";
        if (naming === "UID") {
            this.naming = naming;
        } else if (naming === "AdjectiveNoun") {
            this.naming = naming;
        } else if (uid_regexp.exec(naming)) {
            this.naming = uid_regexp.exec(naming)[1];
        }
    }

    _createClass(jQuery_lookup, [{
        key: 'generateName',
        value: function generateName(path) {
            if (this.naming === "UID") {
                return path.scope.generateUidIdentifierBasedOnNode(path.node);
            } else if (this.naming === "AdjectiveNoun") {
                var name = (0, _adjNoun2.default)().join("_");
                return path.scope.generateUidIdentifier(name);
            } else {
                return path.scope.generateUidIdentifier(this.naming);
            }
        }

        /*Compatibility: Chrome 1, Firefox 3.5, IE 8, Opera 10, Safari 3.2*/

    }, {
        key: '$',
        value: function $(path, args, refVar) {
            if (args.length == 1) {
                if (t.isStringLiteral(args[0])) {
                    if (!refVar) {
                        var statement = (0, _babelTemplate2.default)('var VARNAME = document.querySelectorAll(ARGS0);');
                        var ast = statement({
                            VARNAME: this.generateName(path),
                            ARGS0: args[0]
                        });
                        return ast;
                    } else {

                        var _statement = (0, _babelTemplate2.default)('VARNAME = document.querySelectorAll(ARGS0);');
                        var _ast = _statement({
                            VARNAME: refVar,
                            ARGS0: args[0]
                        });
                        return _ast;
                    }
                } else if (t.isIdentifier(args[0])) {
                    if (!refVar) {
                        var _statement2 = (0, _babelTemplate2.default)('var VARNAME = ARGS0;');
                        var _ast2 = _statement2({
                            VARNAME: this.generateName(path),
                            ARGS0: args[0]
                        });
                        return _ast2;
                    } else {

                        var _statement3 = (0, _babelTemplate2.default)('VARNAME = ARGS0;');
                        var _ast3 = _statement3({
                            VARNAME: refVar,
                            ARGS0: args[0]
                        });
                        return _ast3;
                    }
                } else if (t.isThisExpression(args[0])) {
                    if (!refVar) {
                        var _statement4 = (0, _babelTemplate2.default)('var VARNAME = [ARGS0];');
                        var _ast4 = _statement4({
                            VARNAME: this.generateName(path),
                            ARGS0: args[0]
                        });
                        return _ast4;
                    } else {

                        var _statement5 = (0, _babelTemplate2.default)('VARNAME = [ARGS0];');
                        var _ast5 = _statement5({
                            VARNAME: refVar,
                            ARGS0: args[0]
                        });
                        return _ast5;
                    }
                } else {
                    throw path.buildCodeFrameError("Unexpected argument passed");
                }
            } else if (args.length == 2) {
                //TODO:context
            } else {
                throw path.buildCodeFrameError("Unexpected number of arguments passed");
            }
        }

        /*Compatibility: Chrome 1, IE 9, Edge 12, Firefox 2, Opera, Safari 3*/

    }, {
        key: 'text',
        value: function text(path, args, refVar) {
            if (!refVar) {
                //TODO:error code
            }
            if (args.length == 0) {
                var statement = (0, _babelTemplate2.default)('var TEMP = \'\';\n            for(var i=0;i<REFVAR.length;i++){\n                TEMP += REFVAR[i].textContent;\n            }\n            REFVAR = TEMP;\n            ');
                var ast = statement({
                    REFVAR: refVar,
                    TEMP: this.generateName(path)
                });
                return ast;
            } else if (args.length == 1) {
                var _statement6 = (0, _babelTemplate2.default)('for(var i=0;i<REFVAR.length;i++){\n                                        REFVAR[i].textContent = ARGS0\n                                        }');
                var _ast6 = _statement6({
                    REFVAR: refVar,
                    ARGS0: args[0]
                });
                return _ast6;
            } else {
                throw path.buildCodeFrameError("Unexpected number of arguments passed");
            }
        }

        //TODO: compatibility

    }, {
        key: 'click',
        value: function click(path, args, refVar) {
            if (!refVar) {
                //TODO:error code
            }
            if (args.length == 0) {
                //TODO:trigger click
            } else if (args.length == 1) {
                if (t.isIdentifier(args[0]) || t.isFunctionExpression(args[0])) {
                    var statement = (0, _babelTemplate2.default)('for(var i=0;i<REFVAR.length;i++){\n                REFVAR[i].addEventListener(\'click\', FUNC);\n                }');
                    var ast = statement({
                        REFVAR: refVar,
                        FUNC: args[0]
                    });
                    return ast;
                } else {
                    throw path.buildCodeFrameError("Unexpected argument passed");
                }
            } else if (args.length == 2) {
                //TODO: event data
            } else {
                throw path.buildCodeFrameError("Unexpected number of arguments passed");
            }
        }

        //TODO: compatibility

    }, {
        key: 'on',
        value: function on(path, args, refVar) {
            if (!refVar) {
                //TODO:error code
            }
            if (args.length == 2) {
                var statement = (0, _babelTemplate2.default)('for(var i=0;i<REFVAR.length;i++){\n                                        REFVAR[i].addEventListener(ARGS0,ARGS1);\n                                        }');
            } else if (args.length == 3) {
                //TODO: add child element type
                var _statement7 = (0, _babelTemplate2.default)('var TEMP = ARGS2;\n                                        for(var i=0;i<REFVAR.length;i++){\n                                        REFVAR[i].addEventListener(ARGS0,function(event){\n                                            var TEMP2 = document.querySelectorAll(ARGS1);\n                                            for(var i=0;i< TEMP2.length;i++)\n                                            {\n                                                if(event.target === TEMP2[i])\n                                                {\n                                                    TEMP(event);\n                                                }\n                                            }\n                                        });\n                                        }');
                var ast = _statement7({
                    REFVAR: refVar,
                    TEMP: this.generateName(path),
                    TEMP2: this.generateName(path),
                    ARGS0: args[0],
                    ARGS1: args[1],
                    ARGS2: args[2]
                });
                return ast;
            } else {
                //TODO:
                throw path.buildCodeFrameError("Unexpected number of arguments passed");
            }
        }

        /* Compatibility: Chrome, Edge, Firefox, IE, Opera, Safari */

    }, {
        key: 'css',
        value: function css(path, args, refVar) {
            if (!refVar) {
                //TODO:error code
            }
            if (args.length == 1) {
                if (t.isObjectExpression(args[0])) {
                    //TODO: css dict variable
                } else if (t.isStringLiteral(args[0])) {
                    var res = [];
                    var statement1 = (0, _babelTemplate2.default)('if(REFVAR[0]){\n                REFVAR = getComputedStyle(REFVAR[0])[ARGS];\n                } else {\n                REFVAR = undefined;\n                }');
                    var ast = statement1({
                        REFVAR: refVar,
                        ARGS: args[0]
                    });
                    return ast;
                } else {
                    throw path.buildCodeFrameError("Unexpected argument passed");
                }
            } else if (args.length == 2) {
                if (t.isStringLiteral(args[0]) && t.isStringLiteral(args[1])) {
                    var statement = (0, _babelTemplate2.default)('for(var i=0;i<REFVAR.length;i++){\n                REFVAR[i].style.setProperty(ARGS0,ARGS1);\n                }');
                    var _ast7 = statement({
                        REFVAR: refVar,
                        ARGS0: args[0],
                        ARGS1: args[1]
                    });
                    return _ast7;
                } else {
                    throw path.buildCodeFrameError("Unexpected argument passed");
                }
            } else {
                throw path.buildCodeFrameError("Unexpected number of arguments passed");
            }
        }
    }, {
        key: 'parent',
        value: function parent(path, args, refVar) {
            if (!refVar) {
                //TODO: Error Code
            }
            if (args.length == 0) {
                var statement = (0, _babelTemplate2.default)('var TEMP = [];\n            var TEMP,i=0,j=0;\n            while(TEMP = REFVAR[i++])\n            {\n                if()\n            }\n             ');
                var ast = (0, _babelTemplate2.default)({
                    REFVAR: refVar
                });
            }
        }
    }]);

    return jQuery_lookup;
}();

;

function createLookup(naming) {
    return new jQuery_lookup(naming);
}